Attribute VB_Name = "modDesktop"
Option Explicit
Global oServer As core.CServer
Public Declare Sub DragAcceptFiles Lib "shell32.dll" (ByVal Hwnd As Long, ByVal fAccept As Long)
Public Declare Sub DragFinish Lib "shell32.dll" (ByVal HDROP As Long)
Public Declare Function DragQueryPoint Lib "shell32.dll" (ByVal HDROP As Long, lpPoint As POINTAPI) As Long
Public Declare Function DragQueryFile Lib "shell32.dll" Alias "DragQueryFileA" (ByVal HDROP As Long, ByVal UINT As Long, ByVal lpStr As String, ByVal ch As Long) As Long
Public Declare Function GetNextWindow Lib "user32" Alias "GetWindow" (ByVal Hwnd As Long, ByVal wFlag As Long) As Long
Public Declare Function SetWindowPos Lib "user32" (ByVal Hwnd As Long, ByVal hWndInsertAfter As Long, ByVal x As Long, ByVal y As Long, ByVal cX As Long, ByVal cY As Long, ByVal wFlags As Long) As Long
Public Declare Function GetDesktopWindow Lib "user32" () As Long
Public Declare Function PaintDesktop Lib "user32" (ByVal hdc As Long) As Long
Public Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal Hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Public Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal Hwnd As Long, ByVal nIndex As Long) As Long
Public Declare Sub CopyMemoryDestAddr Lib "kernel32" Alias "RtlMoveMemory" (ByVal hpvDest&, hpvSource As Any, ByVal cbCopy As Long)
Public Declare Sub CopyMemorySrcAddr Lib "kernel32" Alias "RtlMoveMemory" (hpvDest As Any, ByVal hpvSource&, ByVal cbCopy As Long)
Public Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal Hwnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Public Declare Function SystemParametersInfo Lib "user32" Alias "SystemParametersInfoA" (ByVal uAction As Long, ByVal uParam As Long, ByRef lpvParam As Any, ByVal fuWinIni As Long) As Long
Public Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (pDest As Any, pSrc As Any, ByVal ByteLen As Long)
Private Declare Function SHGetSpecialFolderLocation Lib "Shell32" (ByVal hwndOwner As Long, ByVal nFolder As Integer, ppidl As Long) As Long
Private Declare Function SHGetPathFromIDList Lib "Shell32" Alias "SHGetPathFromIDListA" (ByVal pidl As Long, ByVal szPath As String) As Long
Public Enum STGM
    STGM_DIRECT = &H0&
    STGM_TRANSACTED = &H10000
    STGM_SIMPLE = &H8000000
    STGM_READ = &H0&
    STGM_WRITE = &H1&
    STGM_READWRITE = &H2&
    STGM_SHARE_DENY_NONE = &H40&
    STGM_SHARE_DENY_READ = &H30&
    STGM_SHARE_DENY_WRITE = &H20&
    STGM_SHARE_EXCLUSIVE = &H10&
    STGM_PRIORITY = &H40000
    STGM_DELETEONRELEASE = &H4000000
    STGM_CREATE = &H1000&
    STGM_CONVERT = &H20000
    STGM_FAILIFTHERE = &H0&
    STGM_NOSCRATCH = &H100000
End Enum

Public Enum SHOWCMDFLAGS
    SHOWNORMAL = 5
    SHOWMAXIMIZE = 3
    SHOWMINIMIZE = 7
End Enum

Const MAX_PATH = 255

Public Type Setting
    Caption As String
    Value As String
    Name As String
End Type

Public Type lnk
    sLnkFile  As String  ' Link file name
    sExeFile  As String  ' Link - Exe file name
    sWorkDir  As String  '      - Working directory
    sExeArgs  As String  '      - Command line arguments
    sIconFile As String  '      - Icon File name
    lIconIdx  As Long    '      - Icon Index
    lShowCmd  As Long    '      - Program start state.
End Type

Type POINTAPI
        x As Long
        y As Long
End Type

'Constants for GetWindowLong() and SetWindowLong() APIs.
Public Const GWL_WNDPROC = (-4)
Public Const GWL_USERDATA = (-21)

'Used to hold a reference to the control to call its procedure.
'NOTE: "UserControl1" is the UserControl.Name Property at
'      design-time of the .CTL file.
'      ('As Object' or 'As Control' does not work)
Dim oPlugin As CPlugin

'Used as a pointer to the UserData section of a window.
Dim ptrObject As Long

Const SPIF_SENDWININICHANGE = &H2
Const SPI_SETWORKAREA = 47
Const SPI_GETWORKAREA = 48

Public Type WINDOWPOS
    Hwnd As Long
    hWndInsertAfter As Long
    x As Long
    y As Long
    cX As Long
    cY As Long
    flags As Long
End Type


Global Const SWP_NOACTIVATE = &H10
Global Const GW_HWNDNEXT = 2

Global Const SWP_DRAWFRAME = &H20
Global Const SWP_NOMOVE = &H2
Global Const SWP_NOSIZE = &H1

Global Const WM_WINDOWPOSCHANGING = &H46
Global Const WM_LBUTTONDOWN = &H201
Global Const WM_LBUTTONUP = &H202
Global Const WM_LBUTTONDBLCLK = &H203
Global Const WM_RBUTTONDOWN = &H204
Global Const WM_RBUTTONUP = &H205
Global Const WM_RBUTTONDBLCLK = &H206
Global Const WM_MBUTTONDOWN = &H207
Global Const WM_MBUTTONUP = &H208
Global Const WM_MBUTTONDBLCLK = &H209
Global Const WM_USER = &H400
Global Const WM_MENUSELECT = &H11F
Global Const WM_COMMAND = &H111
Global Const WM_SYSCOMMAND = &H112
Global Const WM_DROPFILES = &H233

Global Const HWND_BOTTOM = 1

'--- Autostart code, written by someone else, dono who, cleaned up by me <g>
Public Enum HKeys
    HKEY_CLASSES_ROOT = &H80000000
    HKEY_CURRENT_USER = &H80000001
    HKEY_LOCAL_MACHINE = &H80000002
    HKEY_USERS = &H80000003
    HKEY_PERFORMANCE_DATA = &H80000004
    HKEY_CURRENT_CONFIG = &H80000005
    HKEY_DYN_DATA = &H80000006
End Enum

Public Const READ_CONTROL = &H20000
Public Const STANDARD_RIGHTS_READ = (READ_CONTROL)
Public Const SYNCHRONIZE = &H100000
Public Const KEY_QUERY_VALUE = &H1
Public Const KEY_ENUMERATE_SUB_KEYS = &H8
Public Const KEY_NOTIFY = &H10
Public Const KEY_READ = ((STANDARD_RIGHTS_READ Or KEY_QUERY_VALUE Or KEY_ENUMERATE_SUB_KEYS Or KEY_NOTIFY) And (Not SYNCHRONIZE))
Public Const ERROR_NO_MORE_ITEMS = 259&
Public Const ERROR_SUCCESS = 0&

Type RECT
        left As Long
        top As Long
        right As Long
        bottom As Long
End Type

Declare Function RegCloseKey Lib "advapi32.dll" (ByVal hKey As Long) As Long
Declare Function RegDeleteValue Lib "advapi32.dll" Alias "RegDeleteValueA" (ByVal hKey As Long, ByVal lpValueName As String) As Long
Declare Function RegEnumKey Lib "advapi32.dll" Alias "RegEnumKeyA" (ByVal hKey As Long, ByVal dwIndex As Long, ByVal lpName As String, ByVal cbName As Long) As Long
Declare Function RegEnumValue Lib "advapi32.dll" Alias "RegEnumValueA" (ByVal hKey As Long, ByVal dwIndex As Long, ByVal lpName As String, cbName As Long, ByVal lpReserved As Long, lpType As Long, ByVal lpData As String, lpcbData As Long) As Long
Declare Function RegOpenKeyEx Lib "advapi32.dll" Alias "RegOpenKeyExA" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal ulOptions As Long, ByVal samDesired As Long, phkResult As Long) As Long
Declare Function RegQueryValueEx Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, lpData As Any, lpcbData As Long) As Long

'--- run items in startup folder

Global Const CSIDL_DESKTOP = &H0&               ' \Desktop
Global Const CSIDL_PROGRAMS = &H2&              ' \Start Menu\Programs
Global Const CSIDL_CONTROLS = &H3&              ' No Path
Global Const CSIDL_PRINTERS = &H4&              ' No Path
Global Const CSIDL_PERSONAL = &H5&              ' \Personal
Global Const CSIDL_FAVORITES = &H6&             ' \Favorites
Global Const CSIDL_STARTUP = &H7&               ' \Start Menu\Programs\Startup
Global Const CSIDL_RECENT = &H8&                ' \Recent
Global Const CSIDL_SENDTO = &H9&                ' \SendTo
Global Const CSIDL_BITBUCKET = &HA&             ' No Path
Global Const CSIDL_STARTMENU = &HB&             ' \Start Menu
Global Const CSIDL_DESKTOPDIRECTORY = &H10&     ' \Desktop
Global Const CSIDL_DRIVES = &H11&               ' No Path
Global Const CSIDL_NETWORK = &H12&              ' No Path
Global Const CSIDL_NETHOOD = &H13&              ' \NetHood
Global Const CSIDL_FONTS = &H14&                ' \fonts
Global Const CSIDL_TEMPLATES = &H15&            ' \ShellNew
Global Const CSIDL_COMMON_STARTMENU = &H16&     ' ..\WinNT\profiles\All Users\Start Menu
Global Const CSIDL_COMMON_PROGRAMS = &H17&      ' ..\WinNT\profiles\All Users\Start Menu\Programs
Global Const CSIDL_COMMON_STARTUP = &H18&       ' ..\WinNT\profiles\All Users\Start Menu\Programs\Startup
Global Const CSIDL_COMMON_DESKTOPDIRECTORY = &H19&    '..\WinNT\profiles\All Users\Desktop
Global Const CSIDL_APPDATA = &H1A&              ' ..\WinNT\profiles\username\Application Data
Global Const CSIDL_PRINTHOOD = &H1B&            ' ..\WinNT\profiles\username\PrintHood
Public Function StartUp(RunOnce As Boolean)
    
    Const szRunPath = ("Software\Microsoft\Windows\CurrentVersion\Run")
    Const szRunOncePath = ("Software\Microsoft\Windows\CurrentVersion\RunOnce")
    Const szRunOnceExPath = ("Software\Microsoft\Windows\CurrentVersion\RunOnceEx")
    
    If RunOnce Then
    
        RunEntriesIn HKEY_LOCAL_MACHINE, szRunOnceExPath
        DeleteEntriesIn HKEY_LOCAL_MACHINE, szRunOnceExPath
        RunEntriesIn HKEY_CURRENT_USER, szRunOnceExPath
        DeleteEntriesIn HKEY_CURRENT_USER, szRunOnceExPath
    
        RunEntriesIn HKEY_LOCAL_MACHINE, szRunOncePath
        DeleteEntriesIn HKEY_LOCAL_MACHINE, szRunOncePath
        RunEntriesIn HKEY_CURRENT_USER, szRunOncePath
        DeleteEntriesIn HKEY_CURRENT_USER, szRunOncePath
    
    
    Else
    
        RunEntriesIn HKEY_LOCAL_MACHINE, szRunPath
        RunEntriesIn HKEY_CURRENT_USER, szRunPath
    
    End If

End Function
Function RunEntriesIn(key, Path)
    
    Dim hKey As Long
    Dim lResult As Long
    Dim szNameBuffer As String * 1024
    Dim szValueBuffer As String * 1024
    Dim dwLoop As Integer
    
    lResult = RegOpenKeyEx(key, Path, 0, KEY_READ, hKey)
    If (lResult = ERROR_SUCCESS) Then
        Do
            lResult = RegEnumValue(hKey, dwLoop, szNameBuffer, Len(szNameBuffer), 0, 0, szValueBuffer, Len(szValueBuffer))
            If lResult = ERROR_SUCCESS Then
                Call Shell(left(szValueBuffer, InStr(1, szValueBuffer, Chr(0)) - 1), vbNormalFocus)
                oServer.Execute "!log Starting " & left(szValueBuffer, InStr(1, szValueBuffer, Chr(0)) - 1)
            Else
                Call RegCloseKey(hKey)
                Exit Function
            End If
            dwLoop = dwLoop + 1
        Loop
        Call RegCloseKey(hKey)
    End If

End Function
Private Function DeleteEntriesIn(key As HKeys, Path As String)
    
    Dim hKey  As Long
    Dim lResult As Long
    
    lResult = RegOpenKeyEx(key, Path, 0, KEY_READ, hKey)
    If (lResult = ERROR_SUCCESS) Then
        Dim szNameBuffer As String * 1024, szValueBuffer As String * 1024
        Dim dwLoop As Long, dwNameSize As Long, dwValueSize As Long
        Do
            dwNameSize = Len(szNameBuffer)
            dwValueSize = Len(szValueBuffer)

            lResult = RegEnumValue(hKey, dwLoop, szNameBuffer, dwNameSize, 0, 0, szValueBuffer, dwValueSize)
            If (lResult = ERROR_NO_MORE_ITEMS) Then Call RegCloseKey(hKey): Exit Function
            If (lResult = ERROR_SUCCESS) Then
                lResult = RegDeleteValue(hKey, szNameBuffer)
            If (lResult <> ERROR_SUCCESS) Then Call RegCloseKey(hKey): Exit Function
            End If
        Loop
        Call RegCloseKey(hKey)
    End If

End Function
Public Function fGetSystemFolderPath(ByVal Hwnd As Long, ByVal Id As Integer, sfPath As String) As Long

    Dim lReturn As Long
    Dim lPidl   As Long
    Dim lPath   As Long
    Dim sPath   As String

    sPath = Space$(MAX_PATH)
    lReturn = SHGetSpecialFolderLocation(Hwnd, Id, lPidl)  ' Get lPidl for Id...
    If lReturn = 0 Then                                    ' If success is 0
        lReturn = SHGetPathFromIDList(lPidl, sPath)        '   Get Path from Item Id List
        If lReturn = 1 Then                                '   If success is 1
            sPath = Trim$(sPath)                           '     Fix path string
            lPath = Len(sPath)                             '     Get length of path
            If Asc(right$(sPath, 1)) = 0 Then lPath = lPath - 1 'Adjust path length
            If lPath > 0 Then sfPath = left$(sPath, lPath) '     Adjust path string variable
            fGetSystemFolderPath = True                    '     Return success
        End If
    End If

End Function
Public Function SetDesktopArea(left As Long, top As Long, right As Long, bottom As Long)

    Dim r As RECT

    r.left = left
    r.top = top
    r.right = right
    r.bottom = bottom
    
    SystemParametersInfo SPI_SETWORKAREA, 0, r, SPIF_SENDWININICHANGE
    SystemParametersInfo SPI_GETWORKAREA, 0, r, SPIF_SENDWININICHANGE
    
End Function
'The address of this function is used for subclassing.
'Messages will be sent here and then forwarded to the
'UserControl's WindowProc function. The HWND determines
'to which control the message is sent.
Public Function SubWndProc(ByVal Hwnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long

   On Error Resume Next

   'Get pointer to the control's VTable from the
   'window's UserData section. The VTable is an internal
   'structure that contains pointers to the methods and
   'properties of the control.
   ptrObject = GetWindowLong(Hwnd, GWL_USERDATA)

   'Copy the memory that points to the VTable of our original
   'control to the shadow copy of the control you use to
   'call the original control's WindowProc Function.
   'This way, when you call the method of the shadow control,
   'you are actually calling the original controls' method.
   CopyMemory oPlugin, ptrObject, 4

   'Call the WindowProc function in the instance of the UserControl.
   SubWndProc = oPlugin.WindowProc(Hwnd, Msg, wParam, lParam)

   'Destroy the Shadow Control Copy
   CopyMemory oPlugin, 0&, 4
   Set oPlugin = Nothing

End Function
Public Function fGetShellLinkInfo(sLnkFile As String) As lnk

    Dim lPidl        As Long              ' Item id list
    Dim lHotKey      As Long              ' Hotkey to shortcut...
    Dim lBuffLen     As Long
    Dim sTemp        As String
    Dim sDescription As String
    Dim cShellLink   As ShellLinkA        ' An explorer IShellLink instance
    Dim cPersistFile As IPersistFile      ' An explorer IPersistFile instance
    Dim fd           As WIN32_FIND_DATA '

    If sLnkFile = "" Then Exit Function

    Set cShellLink = New ShellLinkA       ' Create new IShellLink interface
    Set cPersistFile = cShellLink         ' Implement cShellLink's IPersistFile interface

    'Load Shortcut file...(must do this UNICODE hack!)
    On Error GoTo fGetShellLinkInfoError
    cPersistFile.Load StrConv(sLnkFile, vbUnicode), STGM_DIRECT


    With cShellLink
        'Get command line exe name & path of shortcut
        fGetShellLinkInfo.sExeFile = Space$(MAX_PATH)
        lBuffLen = Len(fGetShellLinkInfo.sExeFile)
        .GetPath fGetShellLinkInfo.sExeFile, lBuffLen, fd, SLGP_UNCPRIORITY
        sTemp = fd.cFileName  ' Not returned to calling function

        'Get working directory of shortcut
        fGetShellLinkInfo.sWorkDir = Space$(MAX_PATH)
        lBuffLen = Len(fGetShellLinkInfo.sWorkDir)
        .GetWorkingDirectory fGetShellLinkInfo.sWorkDir, lBuffLen

        'Get command line arguments of shortcut
        fGetShellLinkInfo.sExeArgs = Space$(MAX_PATH)
        lBuffLen = Len(fGetShellLinkInfo.sExeArgs)
        .GetArguments fGetShellLinkInfo.sExeArgs, lBuffLen

        'Get description of shortcut
        sDescription = Space$(MAX_PATH)
        lBuffLen = Len(sDescription)
        .GetDescription sDescription, lBuffLen ' Not returned to calling function

        'Get the HotKey for shortcut
        .GetHotkey lHotKey  ' Not returned to calling function

        'Get shortcut icon location & index
        fGetShellLinkInfo.sIconFile = Space$(MAX_PATH)
        lBuffLen = Len(fGetShellLinkInfo.sIconFile)
        .GetIconLocation fGetShellLinkInfo.sIconFile, lBuffLen, fGetShellLinkInfo.lIconIdx

        'Get Item ID List...
        .GetIDList lPidl ' Not returned to calling function

        'Set shortcut's startup mode (min,max,normal)
        .GetShowCmd fGetShellLinkInfo.lShowCmd
    End With

fGetShellLinkInfoError:
    Set cPersistFile = Nothing
    Set cShellLink = Nothing

End Function
